"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MainTransportAdapter = void 0;
const electron_1 = require("electron");
const inversify_1 = require("inversify");
const event_distributor_1 = require("../../event-distributor/event-distributor");
let MainTransportAdapter = class MainTransportAdapter {
    constructor(eventDistributor) {
        this.eventDistributor = eventDistributor;
    }
    send(pattern, data) {
        this.eventDistributor.broadcast(data);
    }
    register(pattern, handler) {
        electron_1.ipcMain.on(pattern, (event, data) => {
            handler(data);
        });
    }
};
MainTransportAdapter = __decorate([
    inversify_1.injectable(),
    __param(0, inversify_1.inject(event_distributor_1.EventDistributor)),
    __metadata("design:paramtypes", [event_distributor_1.EventDistributor])
], MainTransportAdapter);
exports.MainTransportAdapter = MainTransportAdapter;
