import { Middleware } from '..';
import { BrokerEvent } from '../interfaces/broker-event.interface';
import { IpcTransport } from '../interfaces/ipc-transport.interface';
import { BrokerResponseListenerFactory } from '../types/broker-responser-listener-factory.type';
import { ClassType } from '../types/class.type';
import { ClientExecutionContextFactory } from '../types/client-execution-context-factory.type';
import { MiddlewareExecutorFactory } from '../types/middleware-executor-factory.type';
import { BrokerEventSubscriber } from './event-subscriber/broker-event-subscriber';
export default class DoveClient {
    private ipcTransport;
    private middlewareExecutorFactory;
    private executionContextFactory;
    private brokerResponseListenerFactory;
    private middleware;
    constructor(ipcTransport: IpcTransport, middlewareExecutorFactory: MiddlewareExecutorFactory, executionContextFactory: ClientExecutionContextFactory, brokerResponseListenerFactory: BrokerResponseListenerFactory);
    setMiddleware(middlewares: (ClassType<Middleware> | Middleware)[]): void;
    subscribe<T>(pattern: string, listener: (data: T, brokerEvent?: BrokerEvent) => void): BrokerEventSubscriber;
    send(pattern: string, data: unknown): void;
    invoke<T>(pattern: string, data: unknown): Promise<T>;
    invokeForBrokerEvent(pattern: string, data: unknown): Promise<BrokerEvent>;
    private prepareMiddlewareContext;
    private listenForResponse;
}
