"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BrokerListener = void 0;
const electron_1 = require("electron");
class BrokerListener {
    listen(pattern, listener) {
        this.pattern = pattern;
        this.listener = (event, response) => {
            listener(response);
        };
        electron_1.ipcMain.on(this.pattern, this.listener);
    }
    removeListener() {
        electron_1.ipcMain.removeListener(this.pattern, this.listener);
    }
}
exports.BrokerListener = BrokerListener;
