"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProcessListener = void 0;
class ProcessListener {
    listen(pattern, listener) {
        this.listener = this.injectPatternMatcher(pattern, listener);
        process.on('message', this.listener);
    }
    injectPatternMatcher(pattern, listener) {
        return (response) => {
            if (response.channelName && pattern === response.channelName) {
                listener(response.payload);
            }
        };
    }
    removeListener() {
        process.removeListener('message', this.listener);
    }
}
exports.ProcessListener = ProcessListener;
