"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RendererListener = void 0;
const electron_1 = require("electron");
class RendererListener {
    listen(pattern, listener) {
        this.pattern = pattern;
        this.listener = (event, response) => {
            listener(response);
        };
        electron_1.ipcRenderer.on(this.pattern, this.listener);
    }
    removeListener() {
        electron_1.ipcRenderer.removeListener(this.pattern, this.listener);
    }
}
exports.RendererListener = RendererListener;
