"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ListenerFactory = void 0;
const broker_listener_1 = require("../adapters/broker-listener");
const process_listener_1 = require("../adapters/process-listener");
const renderer_listener_1 = require("../adapters/renderer-listener");
class ListenerFactory {
    static createListener() {
        switch (process.type) {
            case 'renderer':
                return new renderer_listener_1.RendererListener();
            case 'browser':
                return new broker_listener_1.BrokerListener();
            default:
                return new process_listener_1.ProcessListener();
        }
    }
}
exports.ListenerFactory = ListenerFactory;
