"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConfigComposer = void 0;
const symbols_1 = require("../../constants/symbols");
const abstract_container_composer_1 = require("../abstract/abstract-container-composer");
class ConfigComposer extends abstract_container_composer_1.AbstractContainerComposer {
    constructor(container, config) {
        super(container);
        this.config = config;
    }
    compose() {
        this.fillOptionalOptions();
        this.container.bind(symbols_1.Symbols.IpcModuleConfig).toConstantValue(this.config);
    }
    fillOptionalOptions() {
        this.fillControllersIfNotProvided();
    }
    fillControllersIfNotProvided() {
        if (!this.config.controllers) {
            this.config.controllers = [];
        }
    }
}
exports.ConfigComposer = ConfigComposer;
