"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ControllersMetadataFactoryComposer = void 0;
const symbols_1 = require("../../../constants/symbols");
const container_configurable_composer_1 = require("../../abstract/container-configurable-composer");
class ControllersMetadataFactoryComposer extends container_configurable_composer_1.ContainerConfiguarableComposer {
    constructor(container) {
        super(container);
        this.metadataReader = container.get(symbols_1.Symbols.ControllerMetadataReader);
    }
    compose() {
        this.container
            .bind(symbols_1.Symbols.ControllersMetadataFactory)
            .toFactory(() => () => this.getControllersMetadata(this.getControllers()));
    }
    getControllers() {
        return this.getControllersInstances(this.config.controllers);
    }
    getControllersInstances(controllers) {
        return controllers.map((controller) => {
            if (typeof controller === 'object' && controller !== null) {
                return controller;
            }
            return this.container.get(controller);
        });
    }
    getControllersMetadata(controllers) {
        return controllers.map((controller) => this.metadataReader.read(controller));
    }
}
exports.ControllersMetadataFactoryComposer = ControllersMetadataFactoryComposer;
