"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ExecutionContextFactoryComposer = void 0;
const symbols_1 = require("../../../constants/symbols");
const execution_context_1 = require("../../../controllers/execution-context");
const container_configurable_composer_1 = require("../../abstract/container-configurable-composer");
class ExecutionContextFactoryComposer extends container_configurable_composer_1.ContainerConfiguarableComposer {
    compose() {
        this.bindExecutionContextFactory();
        this.bindClientExecutionContextFactory();
    }
    bindExecutionContextFactory() {
        this.container.bind(symbols_1.Symbols.ExecutionContextFactory).toFactory(() => {
            return (metadata, data) => {
                const executionContext = new execution_context_1.ExecutionContext(metadata, data);
                return executionContext;
            };
        });
    }
    bindClientExecutionContextFactory() {
        this.container.bind(symbols_1.Symbols.ClientExecutionContextFactory).toFactory(() => {
            return (brokerEvent) => {
                const executionContext = new execution_context_1.ExecutionContext(undefined, brokerEvent);
                return executionContext;
            };
        });
    }
}
exports.ExecutionContextFactoryComposer = ExecutionContextFactoryComposer;
