"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MiddlewareExecutorFactoryComposer = void 0;
const symbols_1 = require("../../../constants/symbols");
const middleware_executor_1 = require("../../../middleware/middleware-executor");
const container_configurable_composer_1 = require("../../abstract/container-configurable-composer");
class MiddlewareExecutorFactoryComposer extends container_configurable_composer_1.ContainerConfiguarableComposer {
    compose() {
        this.bindMiddlewareExecutorFactory();
    }
    bindMiddlewareExecutorFactory() {
        this.container.bind(symbols_1.Symbols.MiddlewareExecutorFactory).toFactory((context) => {
            return (middlewares) => {
                const middlewareFactory = context.container.get(symbols_1.Symbols.MiddlewareFactory);
                return new middleware_executor_1.MiddlewareExecutor(middlewareFactory, middlewares);
            };
        });
    }
}
exports.MiddlewareExecutorFactoryComposer = MiddlewareExecutorFactoryComposer;
