"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MiddlewareFactoryComposer = void 0;
const inversify_1 = require("inversify");
const lodash_clonedeep_1 = __importDefault(require("lodash.clonedeep"));
const symbols_1 = require("../../../constants/symbols");
const container_configurable_composer_1 = require("../../abstract/container-configurable-composer");
let MiddlewareFactoryComposer = class MiddlewareFactoryComposer extends container_configurable_composer_1.ContainerConfiguarableComposer {
    compose() {
        this.bindMiddlewareFactory();
    }
    bindMiddlewareFactory() {
        this.container.bind(symbols_1.Symbols.MiddlewareFactory).toFactory((context) => {
            return (middleware) => {
                if (typeof middleware === 'object') {
                    return lodash_clonedeep_1.default(middleware);
                }
                try {
                    return context.container.get(middleware);
                }
                catch (err) {
                    return Object.create(middleware.prototype);
                }
            };
        });
    }
};
MiddlewareFactoryComposer = __decorate([
    inversify_1.injectable()
], MiddlewareFactoryComposer);
exports.MiddlewareFactoryComposer = MiddlewareFactoryComposer;
