"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RequestExecutorFactoryComposer = void 0;
const symbols_1 = require("../../../constants/symbols");
const request_executor_1 = require("../../../controllers/request-executor");
const container_configurable_composer_1 = require("../../abstract/container-configurable-composer");
class RequestExecutorFactoryComposer extends container_configurable_composer_1.ContainerConfiguarableComposer {
    compose() {
        this.bindRequestExecutorFactory();
    }
    bindRequestExecutorFactory() {
        this.container.bind(request_executor_1.RequestExecutor).to(request_executor_1.RequestExecutor).inRequestScope();
        this.container.bind(symbols_1.Symbols.RequestExecutorFactory).toAutoFactory(request_executor_1.RequestExecutor);
    }
}
exports.RequestExecutorFactoryComposer = RequestExecutorFactoryComposer;
