"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MiddlewareComposer = void 0;
const internal_middleware_order_1 = require("../../constants/internal-middleware-order");
const symbols_1 = require("../../constants/symbols");
const container_configurable_composer_1 = require("../abstract/container-configurable-composer");
class MiddlewareComposer extends container_configurable_composer_1.ContainerConfiguarableComposer {
    compose() {
        this.bindInternalMiddleware();
        this.bindGlobalMiddleware();
    }
    bindInternalMiddleware() {
        for (const middleware of internal_middleware_order_1.INTERNAL_MIDDLEWARE_ORDER) {
            this.container.bind(symbols_1.Symbols.InternalMiddleware).toConstantValue(middleware);
        }
    }
    bindGlobalMiddleware() {
        this.container.bind(symbols_1.Symbols.GlobalMiddleware).toConstantValue([]);
    }
}
exports.MiddlewareComposer = MiddlewareComposer;
