"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ModeComposer = void 0;
const dove_mode_enum_1 = require("../../constants/dove-mode.enum");
const symbols_1 = require("../../constants/symbols");
const broker_mode_1 = require("../../modes/broker.mode");
const client_mode_1 = require("../../modes/client.mode");
const container_configurable_composer_1 = require("../abstract/container-configurable-composer");
class ModeComposer extends container_configurable_composer_1.ContainerConfiguarableComposer {
    compose() {
        switch (this.config.mode) {
            case dove_mode_enum_1.DoveMode.PROCESS:
                this.container.bind(symbols_1.Symbols.ModuleMode).to(client_mode_1.ClientMode).inSingletonScope();
                break;
            case dove_mode_enum_1.DoveMode.RENDERER:
                this.container.bind(symbols_1.Symbols.ModuleMode).to(client_mode_1.ClientMode).inSingletonScope();
                break;
            case dove_mode_enum_1.DoveMode.BROKER:
                this.container.bind(symbols_1.Symbols.ModuleMode).to(broker_mode_1.BrokerMode).inSingletonScope();
                break;
            default:
                throw new Error('Missing ModuleMode implementation for provided IpcMode');
        }
    }
}
exports.ModeComposer = ModeComposer;
