"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ControllersRegistrator = void 0;
const inversify_1 = require("inversify");
const symbols_1 = require("../constants/symbols");
const request_executor_injector_1 = require("./request-executor-injector");
let ControllersRegistrator = class ControllersRegistrator {
    constructor(requestExecutorInjector, ipcTransport, controllersMetadataFactory) {
        this.requestExecutorInjector = requestExecutorInjector;
        this.ipcTransport = ipcTransport;
        this.controllersMetadataFactory = controllersMetadataFactory;
    }
    register() {
        const controllersMetadata = this.controllersMetadataFactory();
        const messageHandlersWithPattern = this.requestExecutorInjector.injectIntoControllersHandlers(controllersMetadata);
        for (const messageHandlerWithPattern of messageHandlersWithPattern) {
            this.registerMessageHandlers(messageHandlerWithPattern);
        }
    }
    registerMessageHandlers(messageHandlerWithPattern) {
        const { pattern, handler } = messageHandlerWithPattern;
        this.ipcTransport.register(pattern, handler);
    }
};
ControllersRegistrator = __decorate([
    inversify_1.injectable(),
    __param(0, inversify_1.inject(request_executor_injector_1.RequestExecutorInjector)),
    __param(1, inversify_1.inject(symbols_1.Symbols.IpcTransport)),
    __param(2, inversify_1.inject(symbols_1.Symbols.ControllersMetadataFactory)),
    __metadata("design:paramtypes", [request_executor_injector_1.RequestExecutorInjector, Object, Function])
], ControllersRegistrator);
exports.ControllersRegistrator = ControllersRegistrator;
