"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RequestExecutorInjector = void 0;
const inversify_1 = require("inversify");
const symbols_1 = require("../constants/symbols");
let RequestExecutorInjector = class RequestExecutorInjector {
    constructor(executorContextFactory, requestExecutorFactory) {
        this.executorContextFactory = executorContextFactory;
        this.requestExecutorFactory = requestExecutorFactory;
    }
    injectIntoControllersHandlers(controllersMetadata) {
        const registrableMessageHandlers = [];
        for (const controllerMetadata of controllersMetadata) {
            const messageHandlersWithPattern = this.wrapHandlersWithExecutionContext(controllerMetadata.messageHandlers);
            registrableMessageHandlers.push(...messageHandlersWithPattern);
        }
        return registrableMessageHandlers;
    }
    wrapHandlersWithExecutionContext(messageHandlers) {
        const registrableMessageHandlers = [];
        for (const pattern of Object.keys(messageHandlers)) {
            const handlerMetadata = messageHandlers[pattern];
            const handler = this.createAndWrapWithExecutionContext(handlerMetadata);
            registrableMessageHandlers.push({ pattern, handler });
        }
        return registrableMessageHandlers;
    }
    createAndWrapWithExecutionContext(metadata) {
        return (data) => __awaiter(this, void 0, void 0, function* () {
            if (this.isRequest(data)) {
                const requestExecutor = this.requestExecutorFactory();
                const executionContext = this.executorContextFactory(metadata, data);
                requestExecutor.executeRequest(executionContext, metadata);
            }
        });
    }
    isRequest(data) {
        return data.type === 'REQUEST';
    }
};
RequestExecutorInjector = __decorate([
    inversify_1.injectable(),
    __param(0, inversify_1.inject(symbols_1.Symbols.ExecutionContextFactory)),
    __param(1, inversify_1.inject(symbols_1.Symbols.RequestExecutorFactory)),
    __metadata("design:paramtypes", [Function, Function])
], RequestExecutorInjector);
exports.RequestExecutorInjector = RequestExecutorInjector;
