import { ControllerHandlerMetadata } from '../interfaces/controller-handler-metadata.interface';
import Middleware from '../interfaces/middleware.interface';
import { ClassType } from '../types/class.type';
import { MiddlewareExecutorFactory } from '../types/middleware-executor-factory.type';
import { ExecutionContext } from './execution-context';
import { HandlerParamsMapper } from './handler-params-mapper';
export declare class RequestExecutor {
    private internalMiddleware;
    private globalMiddleware;
    private middlewareExecutorFactory;
    private paramsMapper;
    constructor(internalMiddleware: (ClassType<Middleware> | Middleware)[], globalMiddleware: (ClassType<Middleware> | Middleware)[], middlewareExecutorFactory: MiddlewareExecutorFactory, paramsMapper: HandlerParamsMapper);
    executeRequest(context: ExecutionContext, metadata: ControllerHandlerMetadata): Promise<void>;
    private executeHandler;
}
