"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RequestExecutor = void 0;
const inversify_1 = require("inversify");
const symbols_1 = require("../constants/symbols");
const handler_params_mapper_1 = require("./handler-params-mapper");
let RequestExecutor = class RequestExecutor {
    constructor(internalMiddleware, globalMiddleware, middlewareExecutorFactory, paramsMapper) {
        this.internalMiddleware = internalMiddleware;
        this.globalMiddleware = globalMiddleware;
        this.middlewareExecutorFactory = middlewareExecutorFactory;
        this.paramsMapper = paramsMapper;
    }
    executeRequest(context, metadata) {
        return __awaiter(this, void 0, void 0, function* () {
            const middlewareExecutor = this.middlewareExecutorFactory([
                ...this.internalMiddleware,
                ...this.globalMiddleware,
                ...metadata.middleware,
            ]);
            yield middlewareExecutor.execute(context, () => __awaiter(this, void 0, void 0, function* () {
                return yield this.executeHandler(context, metadata);
            }));
        });
    }
    executeHandler(context, metadata) {
        return __awaiter(this, void 0, void 0, function* () {
            const paramsValues = this.paramsMapper.mapBrokerEventData(metadata.paramsMetadata, context.brokerEvent);
            return yield metadata.handler.apply(metadata.controller, paramsValues);
        });
    }
};
RequestExecutor = __decorate([
    inversify_1.injectable(),
    __param(0, inversify_1.multiInject(symbols_1.Symbols.InternalMiddleware)),
    __param(1, inversify_1.inject(symbols_1.Symbols.GlobalMiddleware)),
    __param(2, inversify_1.inject(symbols_1.Symbols.MiddlewareExecutorFactory)),
    __metadata("design:paramtypes", [Array, Array, Function, handler_params_mapper_1.HandlerParamsMapper])
], RequestExecutor);
exports.RequestExecutor = RequestExecutor;
