"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("reflect-metadata");
const decorators_1 = require("../constants/decorators");
function createParamDecorator(method) {
    return (options) => {
        return (target, propertyKey, index) => {
            const args = Reflect.getMetadata(decorators_1.HANDLER_ARGS_METADATA, target[propertyKey]) || [];
            const type = Reflect.getMetadata('design:paramtypes', target, propertyKey);
            const paramMetadata = {
                index: index,
                method: method,
                options: options,
                type: type[index],
            };
            args.push(paramMetadata);
            Reflect.defineMetadata(decorators_1.HANDLER_ARGS_METADATA, args, target[propertyKey]);
        };
    };
}
exports.default = createParamDecorator;
