"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const decorators_1 = require("../constants/decorators");
function UseMiddleware(...middleware) {
    return (target, key, descriptor) => {
        const middlewareArray = middleware ? middleware : [];
        if (descriptor) {
            Reflect.defineMetadata(decorators_1.MIDDLEWARE_METADATA, middlewareArray, descriptor.value);
            return;
        }
        Reflect.defineMetadata(decorators_1.MIDDLEWARE_METADATA, middlewareArray, target.prototype);
        return target;
    };
}
exports.default = UseMiddleware;
