"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BrokerEventConverter = void 0;
const uuid_1 = require("uuid");
const broker_event_data_interface_1 = require("../interfaces/broker-event-data.interface");
class BrokerEventConverter {
    static createOrConvert(pattern, data) {
        let brokerEvent;
        if (broker_event_data_interface_1.isBrokerEventData(data)) {
            brokerEvent = this.fromBrokerEventData(data);
        }
        else {
            brokerEvent = this.createBrokerEvent(pattern, data);
        }
        return brokerEvent;
    }
    static createBrokerEvent(pattern, data) {
        return {
            pattern: 'BROKER_EVENT',
            data: {
                type: 'REQUEST',
                eventId: uuid_1.v4(),
                pattern: pattern,
                data: data,
            },
        };
    }
    static fromBrokerEventData(brokerEventData) {
        return {
            pattern: 'BROKER_EVENT',
            data: brokerEventData,
        };
    }
}
exports.BrokerEventConverter = BrokerEventConverter;
