"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ParamTransformerMiddleware = void 0;
const inversify_1 = require("inversify");
const class_transformer_1 = require("class-transformer");
let ParamTransformerMiddleware = class ParamTransformerMiddleware {
    constructor(transformOptions) {
        this.transformOptions = transformOptions;
    }
    onRequest(executionContext) {
        const paramsMetadata = executionContext.getParamMetadata();
        if (paramsMetadata) {
            for (const paramMetadata of paramsMetadata) {
                const result = paramMetadata.method(paramMetadata.options, executionContext.brokerEvent);
                paramMetadata.method = () => {
                    return class_transformer_1.plainToClass(paramMetadata.type, result, this.transformOptions);
                };
            }
        }
        else {
            throw new Error('ExecutionContext is missing paramMetadata, make sure you are not using the ClassTransformer in DoveClient');
        }
    }
};
ParamTransformerMiddleware = __decorate([
    inversify_1.injectable(),
    __metadata("design:paramtypes", [Object])
], ParamTransformerMiddleware);
exports.ParamTransformerMiddleware = ParamTransformerMiddleware;
exports.default = ParamTransformerMiddleware;
