import ExecutionContext from '../controllers/execution-context';
import Middleware from '../interfaces/middleware.interface';
import { ClassType } from '../types/class.type';
import { MiddlewareFactory } from '../types/middleware-factory.type';
export declare class MiddlewareExecutor {
    private middlewareFactory;
    private middlewares;
    constructor(middlewareFactory: MiddlewareFactory, middlewareList: (ClassType<Middleware> | Middleware)[]);
    private createMiddlewaresObjects;
    execute(executionContext: ExecutionContext, target: () => unknown | Promise<unknown>): Promise<unknown>;
    executeWithoutResponse(executionContext: ExecutionContext, target: () => unknown | Promise<unknown>): Promise<void>;
    private executeOnRequest;
    private executeOnResponse;
}
